#include <def21161.h>

#define N 1024

.section/dm seg_sram;
.var destination[N];

.section/dm seg_dmda;
.var source[N];
.var int_dest[N];
.var DMA_done = 0;
.var DMA1_done = 0;

.section/pm seg_rth;
//EMUI:
	nop;
	nop;
	nop;
	nop;
	
//RSTI:
	nop;
	jump start;
	nop;
	nop;
	
/** IICDI	2**/
	rti;
	nop;
	nop;
	nop;
		
/** SOVFI	3**/
	rti;
	nop;
	nop;
	nop;
		
/** TMZHI	4**/
	rti;
	nop;
	nop;
	nop;

/** VIRPTI	5**/
	rti;
	nop;
	nop;
	nop;
		
/** IRQ2I	6**/
	rti;
	nop;
	nop;
	nop;		
		
/** IRQ1I	7**/
	rti;
	nop;
	nop;
	nop;
		
/** IRQ0I	8**/
	rti;
	nop;
	nop;
	nop;				

/** Resvd3	9**/
	nop;
	nop;
	nop;
	nop;
		
/** SP0I	10**/
	rti;
	nop;
	nop;
	nop;				
		
/** SP1I  11**/
	rti;
	nop;
	nop;
	nop;
		
/** SP2I 12**/
	rti;
	nop;
	nop;
	nop;				
		
/** SP3I	13**/
	rti;
	nop;
	nop;
	nop;
				
/** LP0I **/
	rti;
	nop;
	nop;
	nop;
	
/* LP1I */	
	
	rti;
	nop;
	nop;
	nop;
	
// SPIRI	
	
	rti;
	nop;
	nop;
	nop;

// SPITI
	
	rti;
	nop;
	nop;
	nop;
	
// RSVD	
	
	rti;
	nop;
	nop;
	nop;

// RSVD
	
	rti;
	nop;
	nop;
	nop;
		
/** EP0I	15 **/
	jump _DMA_isr;
	nop;
	nop;
	nop;				

/** EP1I	16 **/
	jump _DMA1_isr;
	nop;
	nop;
	nop;
		
/** EP2I	17 **/
	rti;
	nop;
	nop;
	nop;		
		
/** EP3I	18 **/
	rti;
	nop;
	nop;
	nop;
		
/** LSRQ	19 **/
	rti;
	nop;
	nop;
	nop;
		
/** CB7I	20 **/
	rti;
	nop;
	nop;
	nop;				
		
/** CB15I	21 **/
	rti;
	nop;
	nop;
	nop;
		
	nop;
	nop;
	nop;
	nop;
		
	nop;
	nop;
	nop;
	nop;
		
	nop;
	nop;
	nop;
	nop;
		
	nop;
	nop;
	nop;
	nop;
		
	nop;
	nop;
	nop;
	nop;
		
/** TMZLI	22 **/
	rti;
	nop;
	nop;
	nop;
		
/** FIXI	23 **/
	rti;
	nop;
	nop;
	nop;
		
/** FLTOI	24 **/
	rti;
	nop;
	nop;
	nop;
		
/** FLTUI	25 **/
	rti;
	nop;
	nop;
	nop;				

/** FLTII	26 **/
	rti;
	nop;
	nop;
	nop;
		
/** SFT0I	27 **/
	rti;
	nop;
	nop;
	nop;				
		
/** SFT1I	28 **/
	rti;
	nop;
	nop;
	nop;
		
/** SFT2I	29 **/
	rti;
	nop;
	nop;
	nop;				
		
/** SFT3I	30 **/
	rti;
	nop;
	nop;
	nop;
		
/** Reserved 31 **/
	rti;
	nop;
	nop;
	nop;
	
.endseg;		

	
.section/pm seg_pmco;
start:
	// Initialize the SDRAM controller
	r0 = 0x612;
	dm(SDRDIV) = r0;
	
	r0 = 0x02214231;
	dm(SDCTL) = r0;
	
	r0 = 0x018c0142;
	dm(EPCON) = r0;	
	
	// Enable the external port interrupts
	bit set imask EP0I|EP1I;
	
	bit set mode1 IRPTEN;
	
	// Initialize the source buffer
	i0 = source;
	m0 = 1;
	l0 = 0;
	r0 = 0xFFFFEE00;
	
	lcntr = N, do _init until lce;
	dm(i0,m0) = r0;
_init: r0 = r0 + 1;	

	// Start DMA to write to the external SDRAM
	r0 = 0;
	dm(DMAC10) = r0;
	
	r0 = source;
	dm(IIEP0) = r0;
	
	r0 = 1;
	dm(IMEP0) = r0;
	
	r0 = N;
	dm(CEP0) = r0;
	
	r0 = destination;
	dm(EIEP0) = r0;
	
	r0 = 1;
	dm(EMEP0) = r0;
	
	r0 = N;
	dm(ECEP0) = r0;
	
	ustat1 = TRAN | MASTER | DEN | INT32 | PMODE4;
	dm(DMAC10) = ustat1;
	
	idle;
	
	// Start DMA to read from the external SDRAM
	r0 = 0;
	dm(DMAC11) = r0;
	
	r0 = int_dest;
	dm(IIEP1) = r0;
	
	r0 = 1;
	dm(IMEP1) = r0;
	
	r0 = N;
	dm(CEP1) = r0;
	
	r0 = destination;
	dm(EIEP1) = r0;
	
	r0 = 1;
	dm(EMEP1) = r0;
	
	r0 = N;
	dm(ECEP1) = r0;
	
	ustat1 = MASTER | DEN | INT32 | PMODE4;
	dm(DMAC11) = ustat1;
	
	idle;

loop_here:
	jump loop_here;
	
// External port0 ISR
_DMA_isr:
	r0 = 1;
	dm(DMA_done) = r0;
	
	rti;

// External port 1 ISR		
_DMA1_isr:
	r0 = 1;
	dm(DMA1_done) = r0;
	
	rti;	
